## ukui-screensaver 3.0.3.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(ukui-screensaver)

find_package(Qt5 COMPONENTS Core Widgets DBus X11Extras Xml Network Svg)
find_package(PkgConfig REQUIRED)
find_package(OpenCV REQUIRED)
find_package(PkgConfig)
find_package(X11 REQUIRED)
pkg_check_modules(GIOUNIX2 REQUIRED gio-unix-2.0)
pkg_check_modules(GLIB2 REQUIRED glib-2.0 gio-2.0)

# 是否是intel项目
option (USE_INTEL "intel项目" OFF)
# 用于测试替换用的变量
set(TEST_ON 1)
set(TEST_OF 0)
set(VAR "VAR_NEW")

# 加入一个配置头文件，用于处理 CMake 对源码的设置
configure_file (
  "${CMAKE_CURRENT_SOURCE_DIR}/config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/config.h"
)

set(TS_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/zh_CN.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/es.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/fr.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/pt.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/ru.ts
        ${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/tr.ts
	)
add_custom_command(
	OUTPUT ${TS_FILES}
	COMMAND lupdate src/ screensaver/ -ts ${TS_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)
add_custom_target(
	i18n_ts
	DEPENDS ${TS_FILES}
	)
add_compile_options(-fPIC)

#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INSTALL_PREFIX /usr)

set(Debug ON)
if(Debug)
    set(CMAKE_BUILD_TYPE "Debug")                                                                                                     
endif()

#add_subdirectory(BioAuth)
add_subdirectory(BiometricAuth)
add_subdirectory(VirtualKeyboard)
add_subdirectory(src)
add_subdirectory(i18n_ts)
add_subdirectory(data)
add_subdirectory(screensaver)
add_subdirectory(screensaver-focus-helper)
add_subdirectory(Common)
add_subdirectory(KylinNM)

add_dependencies(ukui-screensaver-dialog BiometricAuth VirtualKeyboard Common)
add_dependencies(ukui-screensaver-default Common)

=== BiometricAuth/CMakeLists.txt ===
qt5_wrap_cpp(BiometricAuth_SRC
	biometricdeviceinfo.h
	biometricproxy.h
	biometricauthwidget.h
	biometricdeviceswidget.h
	giodbus.h
	)

set(BiometricAuth_SRC
	${BiometricAuth_SRC}
	biometricdeviceinfo.cpp
	biometricproxy.cpp
	biometricauthwidget.cpp
	biometricdeviceswidget.cpp
	giodbus.cpp
	)

include_directories(
	${Qt5Core_INCLUDE_DIRS}
	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5DBus_INCLUDE_DIRS}
        ${OpenCV_INCLUDE_DIRS}
        ${GLIB2_INCLUDE_DIRS}
	)


add_library(BiometricAuth STATIC ${BiometricAuth_SRC})
target_link_libraries(BiometricAuth Qt5::Core Qt5::DBus Qt5::Widgets ${OpenCV_LIBS} ${GIOUNIX2_LIBRARIES})

=== KylinNM/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Core Widgets REQUIRED)

set(CMAKE_AUTOMOC ON) 
set(CMAKE_AUTOUIC ON) 
set(CMAKE_AUTORCC ON)
#pkg_check_modules(X11 REQUIRED x11)

qt5_wrap_ui(Kylin_NM_SRC
    src/confform.ui
    src/kylinnm.ui
    src/oneconnform.ui
    src/onelancform.ui
    wireless-security/dlgconnhidwifi.ui
    wireless-security/dlgconnhidwifisecfast.ui
    wireless-security/dlgconnhidwifisectunneltls.ui
    wireless-security/dlgconnhidwifisecpeap.ui
    wireless-security/dlgconnhidwifisectls.ui
    wireless-security/dlgconnhidwifisecleap.ui
    wireless-security/dlgconnhidwifisecpwd.ui
    wireless-security/dlgconnhidwifiwep.ui
    wireless-security/dlgconnhidwifileap.ui
    wireless-security/dlgconnhidwifiwpa.ui
    hot-spot/dlghotspotcreate.ui
    )

#qt5_wrap_cpp(Kylin_NM_SRC
#    src/backthread.h
#    src/confform.h
#    src/ksimplenm.h
#    src/kylin-dbus-interface.h
#    src/kylin-network-interface.h
#    src/loadingdiv.h
#    src/kylinnm.h
#    src/oneconnform.h
#    src/onelancform.h
#    src/switchbutton.h
#    src/utils.h
#    wireless-security/dlgconnhidwifi.h
#    wireless-security/dlgconnhidwifisecfast.h
#    wireless-security/dlgconnhidwifisectunneltls.h
#    wireless-security/dlgconnhidwifisecpeap.h
#    wireless-security/dlgconnhidwifisectls.h
#    wireless-security/dlgconnhidwifisecleap.h
#    wireless-security/dlgconnhidwifisecpwd.h
#    wireless-security/dlgconnhidwifiwep.h
#    wireless-security/dlgconnhidwifileap.h
#    wireless-security/dlgconnhidwifiwpa.h
#    wireless-security/kylinheadfile.h
#    hot-spot/dlghotspotcreate.h
#    )

qt5_add_resources(Kylin_NM_SRC
    nmqrc.qrc
    res.qrc)

set(Kylin_NM_SRC
    ${Kylin_NM_SRC}
    src/backthread.cpp
    src/confform.cpp
    src/ksimplenm.cpp
    src/kylin-dbus-interface.cpp
    src/kylin-network-interface.c
    src/loadingdiv.cpp
    src/kylinnm.cpp
    src/oneconnform.cpp
    src/onelancform.cpp
    src/switchbutton.cpp
    src/utils.cpp
    src/swipegesturerecognizer.cpp
    wireless-security/dlgconnhidwifi.cpp
    wireless-security/dlgconnhidwifisecfast.cpp
    wireless-security/dlgconnhidwifisectunneltls.cpp
    wireless-security/dlgconnhidwifisecpeap.cpp
    wireless-security/dlgconnhidwifisectls.cpp
    wireless-security/dlgconnhidwifisecleap.cpp
    wireless-security/dlgconnhidwifisecpwd.cpp
    wireless-security/dlgconnhidwifiwep.cpp
    wireless-security/dlgconnhidwifileap.cpp
    wireless-security/dlgconnhidwifiwpa.cpp
    wireless-security/kylinheadfile.cpp
    hot-spot/dlghotspotcreate.cpp
    nmqrc.qrc
    )

include_directories(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    )

find_package(KF5WindowSystem)

add_library(Kylin-nm STATIC ${Kylin_NM_SRC})
target_link_libraries(Kylin-nm Qt5::Core Qt5::Widgets KF5::WindowSystem Qt5::DBus Qt5::X11Extras)

=== data/CMakeLists.txt ===
install(FILES org.ukui.screensaver.gschema.xml DESTINATION /usr/share/glib-2.0/schemas)
install(FILES ukui-screensaver.desktop DESTINATION /etc/xdg/autostart)
install(FILES ukui-screensaver.directory DESTINATION /usr/share/desktop-directories)
install(FILES ukui-screensavers.menu DESTINATION /etc/xdg/menus)
install(FILES ukui-screensaver-qt DESTINATION /etc/pam.d)

=== i18n_ts/CMakeLists.txt ===
find_package(Qt5LinguistTools)

file(GLOB ts_files *.ts)
qt5_add_translation(qm_files ${ts_files})
add_custom_target(i18n
	DEPENDS ${qm_files}
	SOURCES ${ts_files}
	)
# 让主目标依赖翻译文件，这样才会执行i18n
add_dependencies(ukui-screensaver-dialog i18n)

install(FILES ${qm_files} DESTINATION /usr/share/ukui-screensaver/i18n_qm/)

=== screensaver-focus-helper/CMakeLists.txt ===
project(screensaver-capslock-helper)
  
set(CMAKE_AUTOMOC ON)

set(bin_SRCS
    ${bin_SRCS}
    main.cpp
    )

add_executable(screensaver-focus-helper ${bin_SRCS})
target_link_libraries(screensaver-focus-helper Qt5::Core  Qt5::Widgets)

install(TARGETS
        screensaver-focus-helper
	DESTINATION lib/ukui-screensaver)

=== screensaver/CMakeLists.txt ===
pkg_check_modules(X11 REQUIRED x11)
pkg_check_modules(XTST REQUIRED xtst)
pkg_check_modules(QGS REQUIRED gsettings-qt)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}/Common)

include_directories(
	${X11_INCLUDE_DIRS}
        ${XTST_INCLUDE_DIRS}
	${QGS_INCLUDE_DIRS}
	)

set(EXTRA_LIBS
	${EXTRA_LIBS}
	${X11_LIBRARIES}
        ${XTST_LIBRARIES}
	${QGS_LIBRARIES}
	Common
	)
qt5_add_resources(screensaver_SRC
	default.qrc
	)

qt5_wrap_cpp(screensaver_SRC
    chinesedate.h
    screensaver.h
    mbackground.h
    cyclelabel.h
    scconfiguration.h
    sleeptime.h
    weathermanager.h
    ../src/networkwatcher.h
    )
set(screensaver_SRC
    ${screensaver_SRC}
    main.cpp
    chinesedate.cpp
    mbackground.cpp
    screensaver.cpp
    cyclelabel.cpp
    scconfiguration.cpp
    sleeptime.cpp
    weathermanager.cpp
    ../src/networkwatcher.cpp
    )
add_executable(ukui-screensaver-default ${screensaver_SRC})
target_link_libraries(ukui-screensaver-default Qt5::Core Qt5::Widgets Qt5::X11Extras Qt5::Xml Qt5::Network ${EXTRA_LIBS})

install(TARGETS
	ukui-screensaver-default
	DESTINATION lib/ukui-screensaver)

install(FILES
        language/screensaver-zh_CN.ini 
	language/screensaver-en_US.ini
	language/screensaver-jd.ini
        DESTINATION share/ukui-screensaver/language)

=== src/CMakeLists.txt ===
pkg_check_modules(X11 REQUIRED x11)
pkg_check_modules(XTST REQUIRED xtst)
pkg_check_modules(XCB REQUIRED xcb)
pkg_check_modules(QGS REQUIRED gsettings-qt)

pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(MMIX REQUIRED libmatemixer)

find_library(PAM_LIBRARIES pam)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}/VirtualKeyboard/src)
include_directories(${PROJECT_SOURCE_DIR}/BiometricAuth)
include_directories(${PROJECT_SOURCE_DIR}/Common)
include_directories(${PROJECT_SOURCE_DIR}/KylinNM)
include_directories(${PROJECT_SOURCE_DIR}/KylinNM/src)
include_directories(${PROJECT_SOURCE_DIR}/KylinNM/hot-spot)
include_directories(${PROJECT_SOURCE_DIR}/KylinNM/wireless-security)

include_directories(
    ${X11_INCLUDE_DIRS}
    ${XTST_INCLUDE_DIRS}
    ${XCB_INCLUDE_DIRS}
    ${QGS_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
    ${MMIX_INCLUDE_DIRS}
    )

set(EXTRA_LIBS
    ${EXTRA_LIBS}
    ${PAM_LIBRARIES}
    ${X11_LIBRARIES}
    ${XTST_LIBRARIES}
    ${XCB_LIBRARIES}
    ${QGS_LIBRARIES}
    ${GLIB_LIBRARIES}
    ${MMIX_LIBRARIES}
    -lrt
    )

qt5_wrap_ui(dialog_SRC
    lockwidget.ui
    )

qt5_add_resources(dialog_SRC
    assets.qrc
    ../KylinNM/nmqrc.qrc  #暂时将麒麟网络的资源文件放到这里，否则显示不出来，暂时不知道原因
    )

# 头文件中包含了Xlib.h，需要单独拿出来处理，不知道原因
qt5_wrap_cpp(dialog_SRC
    pam-tally.h
    fullbackgroundwidget.h
    lockwidget.h
    authdialog.h
    screensaverwidget.h
    auth.h
    auth-pam.h
    screensaver.h
    xeventmonitor.h
    monitorwatcher.h
    configuration.h
    users.h
    displaymanager.h
    iconedit.h
    powermanager.h
    logind.h
    weathermanager.h
    tabletlockwidget.h
    gestureauthdialog.h
    digitalauthdialog.h
    switchbuttongroup.h
    wechatauthdialog.h
    verificationwidget.h
    verticalVerificationwidget.h
    common.h
    eduplatforminterface.h
    accountsinterface.h
    networkwatcher.h
    digitalkeyboard.h
    PhysicalDeviceSet/brightnessdeviceset.h
    PhysicalDeviceSet/flightmodeset.h
    PhysicalDeviceSet/sounddeviceset.h
    PhysicalDeviceSet/touchscreenset.h
    )

set(dialog_SRC
    ${dialog_SRC}
        pam-tally.c
    ukui-screensaver-dialog.cpp
    fullbackgroundwidget.cpp
    lockwidget.cpp
    authdialog.cpp
    screensaverwidget.cpp
    auth-pam.cpp
    xeventmonitor.cpp
    monitorwatcher.cpp
    grab-x11.cpp
    configuration.cpp
    screensaver.cpp
    powermanager.cpp
    users.cpp
    displaymanager.cpp
    iconedit.cpp
    logind.cpp
    weathermanager.cpp
    tabletlockwidget.cpp
    gestureauthdialog.cpp
    digitalauthdialog.cpp
    switchbuttongroup.cpp
    wechatauthdialog.cpp
    verificationwidget.cpp
    verticalVerificationwidget.cpp
    eduplatforminterface.cpp
    accountsinterface.cpp
    networkwatcher.cpp
    digitalkeyboard.cpp
    PhysicalDeviceSet/brightnessdeviceset.cpp
    PhysicalDeviceSet/flightmodeset.cpp
    PhysicalDeviceSet/sounddeviceset.cpp
    PhysicalDeviceSet/touchscreenset.cpp
    )
add_executable(ukui-screensaver-dialog ${dialog_SRC})

target_link_libraries(ukui-screensaver-dialog
	Qt5::Core
	Qt5::Widgets
	Qt5::DBus
	Qt5::Svg
	Qt5::X11Extras
        Qt5::Network
	${EXTRA_LIBS}
    BiometricAuth 
	VirtualKeyboard 
	Common
        Kylin-nm
	)
link_libraries(libmatemixer.so glib-2.0.so)

qt5_add_dbus_adaptor(backend_SRC
    org.ukui.ScreenSaver.xml
    interface.h
    Interface
    )

qt5_wrap_cpp(backend_SRC
    interface.h
    sessionwatcher.h
    logind.h
    )
set(backend_SRC
    ${backend_SRC}
    ukui-screensaver-backend.cpp
    interface.cpp
    sessionwatcher.cpp
    logind.cpp
    )
add_executable(ukui-screensaver-backend ${backend_SRC})
target_link_libraries(ukui-screensaver-backend Qt5::Core Qt5::DBus ${QGS_LIBRARIES})

set(command_SRC
    ukui-screensaver-command.cpp
    )
add_executable(ukui-screensaver-command ${command_SRC})
target_link_libraries(ukui-screensaver-command Qt5::Core Qt5::DBus)

set(checkpass_SRC
    ukui-screensaver-checkpass.cpp
    )
add_executable(ukui-screensaver-checkpass ${checkpass_SRC})
target_link_libraries(ukui-screensaver-checkpass ${PAM_LIBRARIES})

install(TARGETS
    ukui-screensaver-dialog
    ukui-screensaver-backend
    ukui-screensaver-command
    ukui-screensaver-checkpass
    DESTINATION bin)

#set(test-act_SRC
#	users.cpp
#	test-accounts.cpp
#	)
#add_executable(test-accounts ${test-act_SRC})
#target_link_libraries(test-accounts Qt5::Core Qt5::DBus)

=== debian/changelog ===
ukui-screensaver (3.0.3.4-1) unstable; urgency=medium

  * Set minimum CMake version to 3.5 to fix FTBFS with CMake 4.
    (Closes: #1113601)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 04 Nov 2025 14:49:37 +0800

=== debian/control ===
Source: ukui-screensaver
Section: x11
Priority: optional
Maintainer: Kylin Team <team+kylin@tracker.debian.org>
Uploaders: Aron Xu <aron@debian.org>,
           handsome_feng <jianfengli@ubuntukylin.com>
Build-Depends: cmake (>=2.6),
               debhelper-compat (= 12),
               libglib2.0-dev,
               libgsettings-qt-dev,
               libkf5windowsystem-dev,
               libmatemixer-dev,
               libopencv-dev,
               libpam0g-dev,
               libqt5svg5-dev,
               libqt5x11extras5-dev,
               libx11-dev,
               libxtst-dev,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://www.github.com/ukui/ukui-screensaver
Vcs-Git: https://github.com/ukui/ukui-screensaver.git
Vcs-Browser: https://github.com/ukui/ukui-screensaver

Package: ukui-screensaver
Architecture: any
Depends: mate-desktop-common,
         ukui-session-manager,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: ukui-screensaver-common (<< 2.0.0)
Description: Screensaver for UKUI desktop environment
 A simple and lightweight screensaver written by Qt5.
 The screensaver supports biometric auhentication which is
 provided by biometric-auth service.

=== debian/watch ===
version=4
https://gitee.com/openkylin/ukui-screensaver/releases/ .*/ukui-screensaver-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
